# options for components
# Build with PostgreSQL support
%define with_pgsql	1
# Build with MySQL support
%define with_mysql 	1
# Build with LDAP support
%define with_ldap	1
# Build with multi_lookups methods
%define with_multi	1
%define docver 4.30
%define exiscan_acl_version 4.30-14
%define ftpurl ftp://ftp.csx.cam.ac.uk/pub/software/email/exim/exim4

Name: exim
Version: 4.30
Release: alt1.1

Summary: Exim MTA
License: GPL
Group: System/Servers
URL: http://www.exim.org/
Source0: %ftpurl/exim-%version.tar.bz2
Source1: %ftpurl/exim-texinfo-%docver.tar.bz2
Source2: %ftpurl/exim-pdf-%docver.tar.bz2
Source3: %ftpurl/exim-postscript-%docver.tar.bz2
Source4: %ftpurl/exim-html-%docver.tar.bz2
Source5: %ftpurl/FAQ.txt.bz2
Source6: %ftpurl/FAQ-html.tar.bz2
Source7: %ftpurl/config.samples.tar.bz2
Source9: exim.init
Source10: exim.logrotate
Source101: exim.sysconfig
Source11: eximon.desktop
Source12: exim_aliases
Source13: exim.aliases
Source14: exim.cron
Source15: eximclean
Source18: exim.pam
Source19: exim.configure.default.alt
Source20: Makefile.base
Source21: eximon.conf
Source22: Makefile.multi
Source23: Makefile.ldap
Source24: Makefile.mysql
Source25: Makefile.pgsql
Source31: oview.txt
Source32: oview.ps
Source33: oview.pdf
Source34: oview.texinfo
Source35: exim.init.master
Source36: README.ALT
Source37: eximon.menu
Source42: exiscan-CHANGELOG

Patch0: exim-4.30-Configure-Makefile.patch
Patch1: http://duncanthrax.net/exiscan-acl/exiscan-acl-%{exiscan_acl_version}.patch

# Automatically added by buildreq on Wed Dec 03 2003
BuildRequires: XFree86-devel XFree86-libs libdb4.1-devel libkrb5 libpam-devel libssl-devel libwhoson-devel libwrap-devel perl-devel xpm libwhoson


%if %with_ldap
BuildRequires: libldap-devel
%endif
%if %with_mysql
BuildRequires: libMySQL-devel
%endif
%if %with_pgsql
BuildRequires: postgresql-devel libpq3-devel
%endif
%if %with_multi
BuildRequires: libldap-devel libMySQL-devel postgresql-devel libpq3-devel
%endif

Provides: smtpdaemon, smtpd, MTA, MailTransferAgent

Requires: exim-mta

Requires: perl-base,libpam0,libwrap,libldap,libdb4.1,libssl libwhoson whoson-server
Requires: sendmail-common

Conflicts: sendmail,postfix,masqmail

%description
Smail like Mail Transfer Agent with single configuration file.
Features: flexible retry algorithms, header & envelope rewriting,
multiple deliveries down single connection or multiple deliveries in
parallel, regular expressions in configuration parameters, file
lookups, supports sender and/or reciever verification, selective
relaying, supports virtual domains, built-in mail filtering and can be
configured to drop root privilleges when possible.

%package monitor
Summary: Exim - Exceptional Internet Mailer - X mail monitor
Group: Monitoring
BuildRequires: XFree86-devel
Requires: %name = %version-%release
Requires: XFree86-libs
License: GPL

%description monitor
X Window based monitor & administration utility for the Exim Mail
Transfer Agent.

%package html-doc
Summary: Exim - Exceptional Internet Mailer - HTML documentation
Group: System/Servers
Requires: %name = %version

%description html-doc
All the HTML documentation on exim

%package postscript-doc
Summary: Exim - Exceptional Internet Mailer - Documentation
Group: System/Servers
Requires: %name = %version

%description postscript-doc
Postscript documentation for exim

%package pdf-doc
Summary: Exim - Exceptional Internet Mailer - Documentation
Group: System/Servers
Requires: %name = %version

%description pdf-doc
Adobe PDF documentation for exim

%package info
Summary: Exim - Exceptional Internet Mailer - Info documentation
Group: System/Servers
Requires: %name = %version

%description info
Info format documentation for exim

%package base
Summary: Main exim MTA program, compiled with basic libraries
Group: System/Servers
Provides: exim-mta, smtpd, smtpdaemon
Provides: %name-base = %version-%release
Conflicts: exim-mysql, exim-pgsql, exim-multi, exim-ldap
PreReq:	%name = %version-%release

%description base
The main exim MTA program, compiled with all basic dbm lookups support,
TLS (SSL), LDAP and all the main transports.  This should suit all general
purpose systems, and is the smallest binary.

%package mysql
Summary: Main exim MTA program, compiled with basic libraries + perl + mysql
Group: System/Servers
Provides: exim-mta
Conflicts: exim-base,  exim-pgsql, exim-multi, exim-ldap
PreReq:	%name = %version-%release, libMySQL
Requires(post,preun): %__subst

%description mysql
The main exim MTA program, compiled with all basic dbm lookups support,
TLS (SSL), LDAP and all the main transports, plus embedded perl support
and mysql db lookup support.

%package pgsql
Summary: Main exim MTA program, compiled with basic libraries + perl + pgsql
Group: System/Servers
Provides: exim-mta
Conflicts: exim-base, exim-mysql, exim-multi, exim-ldap
PreReq:	%name = %version-%release, libpq3

%description pgsql
The main exim MTA program, compiled with all basic dbm lookups support,
TLS (SSL), LDAP and all the main transports, plus embedded perl support
and postgresql lookups.

%package multi
Summary: Main exim MTA program, compiled with basic libraries + perl + pgsql + MySQL
Group: System/Servers
Provides: exim-mta, smtpd, smtpdaemon
Provides: %name-multi = %version-%release
Conflicts: exim-base, exim-pgsql, exim-mysql, exim-ldap
PreReq:	%name = %version-%release, libMySQL, libpq3
#Requires: %name = %version-%release,libMySQL,libpq3

%description multi
The main exim MTA program, compiled with all basic dbm lookups support,
TLS (SSL), LDAP and all the main transports, plus embedded perl support
and postgresql and MySQL lookups.

%package ldap
Summary: Main exim MTA program, compiled with basic libraries + perl + ldap
Group: System/Servers
Provides: exim-mta
Conflicts: exim-base, exim-mysql, exim-multi, exim-pgsql
PreReq:	%name = %version-%release, libldap

%description ldap
The main exim MTA program, compiled with all basic dbm lookups support,
TLS (SSL), LDAP and all the main transports, plus embedded perl support.


%package utils
Summary: Misc utils for debugging exim: cramtest.pl logargs unknowuser
Group: System/Servers
Requires: exim-mta

%description utils
Misc utils for debugging exim: cramtest.pl logargs unknowuser

%prep
%setup -q -n exim-%{version} -a 1 -a 2 -a 3 -a 4

# relocate the doc files into the tree from their own
# directory sets
for dir in exim-{html,pdf,postscript,texinfo}-%{docver}
do
  mv $dir/doc/* doc/
  rm -rf $dir
done

cp %{SOURCE5} %{SOURCE6} %{SOURCE7} %{SOURCE31} %{SOURCE32} %{SOURCE33} %{SOURCE34} %{SOURCE36} %{SOURCE42} doc/
bzip2 -d  doc/FAQ.txt.bz2

install -d Local
%patch0 -p1
%patch1 -p1
subst s/DIGEST/Digest/ util/cramtest.pl

install %{SOURCE21} Local/eximon.conf

%build
# we build several versions here...
mkdir bins
versions="base"
%if %{with_ldap}
versions="ldap $versions"
%endif
%if %{with_mysql}
versions="mysql $versions"
%endif
%if %{with_pgsql}
versions="pgsql $versions"
%endif
%if %{with_multi}
versions="multi $versions"
%endif

for version in $versions
do
 (cd Local; cp %_sourcedir/Makefile.$version Makefile)
 make CFLAGS="$RPM_OPT_FLAGS"
 cp build-`scripts/os-type`-`scripts/arch-type`/exim bins/exim-$version
done


%{__make} CFLAGS="$RPM_OPT_FLAGS" $FLAGS \
	LOOKUP_LIBS="$LOOKUP_LIBS" \
	LOOKUP_INCLUDE="$LOOKUP_INCLUDE"

makeinfo doc/oview.texinfo
makeinfo doc/spec.texinfo
makeinfo doc/filter.texinfo

%install
install -d $RPM_BUILD_ROOT/etc/{cron.{daily,weekly},logrotate.d,rc.d/init.d,sysconfig,exim,pam.d} \
	$RPM_BUILD_ROOT{%{_bindir},%{_sbindir},%{_mandir}/man8,%{_libdir}} \
	$RPM_BUILD_ROOT%{_var}/{spool/exim/{db,input,msglog},log/{archiv,}/exim,mail} \
	$RPM_BUILD_ROOT{%_infodir,%_x11bindir,%_applnkdir/System} \
	$RPM_BUILD_ROOT%{_docdir}/%name-%version \
	$RPM_BUILD_ROOT%{_menudir}

install bins/exim* $RPM_BUILD_ROOT/usr/sbin

install build-Linux-i386/exim_{fixdb,tidydb,dbmbuild,dumpdb,lock} \
	build-Linux-i386/exi{cyclog,next,what} %{SOURCE12} %{SOURCE15} \
	util/{cramtest.pl,logargs.sh,unknownuser.sh} \
	build-Linux-i386/{exigrep,exim_checkaccess,eximstats,exiqsumm,exiqgrep} \
	$RPM_BUILD_ROOT%{_bindir}
install build-Linux-i386/eximon.bin $RPM_BUILD_ROOT%_x11bindir
install build-Linux-i386/eximon $RPM_BUILD_ROOT%_x11bindir

install -m755 %{SOURCE14} $RPM_BUILD_ROOT/etc/cron.weekly/
install -m755 %{SOURCE9} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install -m644 %{SOURCE101} $RPM_BUILD_ROOT/etc/sysconfig/%{name}
install	-m644 %{SOURCE10} $RPM_BUILD_ROOT/etc/logrotate.d/%{name}
install -m644 %{SOURCE18} $RPM_BUILD_ROOT/etc/pam.d/exim
install -m644 %{SOURCE19} $RPM_BUILD_ROOT/etc/exim/exim.conf

install doc/exim.8 $RPM_BUILD_ROOT%{_mandir}/man8/
#install %{SOURCE13} $RPM_BUILD_ROOT%{_sysconfdir}/exim/aliases
install	*.info* $RPM_BUILD_ROOT%{_infodir}/

#ln -sf %{_bindir}/exim $RPM_BUILD_ROOT%{_sbindir}/exim
ln -sf %{_sbindir}/exim $RPM_BUILD_ROOT%{_sbindir}/sendmail
#ln -sf %{_sbindir}/exim $RPM_BUILD_ROOT%{_libdir}/sendmail
ln -sf %{_sbindir}/exim $RPM_BUILD_ROOT%{_sbindir}/mailq
ln -sf %{_sbindir}/exim $RPM_BUILD_ROOT%{_sbindir}/rsmtp
ln -sf %{_sbindir}/exim $RPM_BUILD_ROOT%{_sbindir}/rmail
ln -sf %{_sbindir}/exim $RPM_BUILD_ROOT%{_sbindir}/runq

install -p -m644 %{SOURCE37} $RPM_BUILD_ROOT%{_menudir}/eximon
install %{SOURCE35} doc/
touch $RPM_BUILD_ROOT%{_var}/log/exim/{main,reject,panic,filter}.log

%post
if [ $1 = 1 ]; then
    /sbin/chkconfig --add %{name}
    echo "Run \"service %{name} start\" to start exim daemon."
fi
/usr/sbin/update-alternatives --install %{_sysconfdir}/aliases aliases %{_sysconfdir}/%{name}/aliases 20
ALIASES=%{_sysconfdir}/%{name}/aliases /usr/share/sendmail-common/rebuild_aliases
exim_aliases

chown -R mail:mail /var/spool/exim/{db,input,msglog} /var/log/exim

%preun
if [ $1 = 0 ]; then
%{_initdir}/%{name} condstop >&2
/usr/sbin/update-alternatives --remove aliases %{_sysconfdir}/%{name}/aliases
/sbin/chkconfig --del %{name}
fi

%post info
  install-info --section="Exim" \
      --entry "* Overview: (exim_oview).    Overview of the Exim system" \
      %{_infodir}/exim_oview.info.* %{_infodir}/dir
  install-info --section="Exim" \
      --entry "* User guide: (exim).           Exim manual" \
      %{_infodir}/exim.info.* %{_infodir}/dir
  install-info --section="Exim" \
      --entry "* Filtering: (exim_filter).     Filtering mail with Exim" \
      %{_infodir}/exim_filter.info.* %{_infodir}/dir

%preun info
if [ $1 = 0 ]; then
  install-info --delete --section="Exim" \
      --entry "* Overview: (exim_oview).    Overview of the Exim system" \
      %{_infodir}/exim_oview.info.* %{_infodir}/dir
  install-info --delete --section="Exim" \
      --entry "* User guide: (exim).           Exim manual" \
      %{_infodir}/exim.info.* %{_infodir}/dir
  install-info --delete --section="Exim" \
      --entry "* Filtering: (exim_filter).     Filtering mail with Exim" \
      %{_infodir}/exim_filter.info.* %{_infodir}/dir
fi

%post monitor
%update_menus

%postun monitor
%clean_menus

%post base
ln -sf /usr/sbin/exim-base /usr/sbin/exim
%{_initdir}/%{name} condrestart >&2

%if %{with_mysql}
%post mysql
ln -sf /usr/sbin/exim-mysql /usr/sbin/exim
%{_initdir}/%{name} condrestart >&2
%endif

%if %{with_pgsql}
%post pgsql
ln -sf /usr/sbin/exim-pgsql /usr/sbin/exim
%{_initdir}/%{name} condrestart >&2
%endif

%if %{with_multi}
%post multi
ln -sf /usr/sbin/exim-multi /usr/sbin/exim
%{_initdir}/%{name} restart >&2
%endif

%if %{with_ldap}
%post ldap
ln -sf /usr/sbin/exim-ldap /usr/sbin/exim
%{_initdir}/%{name} restart >&2
%endif


%files
%doc README* NOTICE LICENCE doc/exim.init.master
%doc doc/{ChangeLog,NewStuff,dbm.discuss.txt,filter.txt,oview.txt,spec.txt}
#%doc util/transport-filter.pl

%config(noreplace) %{_sysconfdir}/exim/exim.conf
#%attr( 644,root,root) %config(noreplace) %{_sysconfdir}/exim/aliases
%config(noreplace) /etc/sysconfig/exim
%config(noreplace) /etc/logrotate.d/exim
%_initrddir/exim
/etc/pam.d/exim
/etc/cron.weekly/exim.cron

#%attr(4755,exim,exim) %{_bindir}/exim

%_bindir/exim_*
%_bindir/exinext
%_bindir/exiwhat
%_bindir/exicyclog
%_bindir/exigrep
%_bindir/eximstats
%_bindir/exiqsumm
%_bindir/exiqgrep
#%attr( 755,root,root) %{_sbindir}/exim
%_sbindir/mailq
%_sbindir/rmail
%_sbindir/rsmtp
%_sbindir/runq
%_sbindir/sendmail
%_mandir/man8/*

%attr(770,root,mail) %dir %{_var}/spool/exim
%attr(750,mail,mail) %dir %{_var}/spool/exim/db
%attr(700,mail,mail) %dir %{_var}/spool/exim/input
%attr(750,mail,mail) %dir %{_var}/spool/exim/msglog
%attr(750,mail,mail) %dir %{_var}/log/exim
#%attr(640,mail,mail) %{_var}/log/exim/

%files monitor
%_x11bindir/*
%_menudir/*

%files html-doc
%doc doc/html/*

%files postscript-doc
%doc doc/*.ps

%files pdf-doc
%doc doc/*.pdf

%files info
%_infodir/*

%files base
%attr(4711,root,root)/usr/sbin/exim-base
#%ghost /usr/sbin/exim


%if %{with_mysql}
%files mysql
%attr(4711,root,root)/usr/sbin/exim-mysql
#%ghost /usr/sbin/exim
%endif

%if %{with_pgsql}
%files pgsql
%attr(4711,root,root)/usr/sbin/exim-pgsql
#%ghost /usr/sbin/exim
%endif

%if %{with_ldap}
%files ldap
%attr(4711,root,root)/usr/sbin/exim-ldap
#%ghost /usr/sbin/exim
%endif


%if %{with_multi}
%files multi
%attr(4711,root,root)/usr/sbin/exim-multi
#%ghost /usr/sbin/exim
%endif

%files utils
%_bindir/cramtest.pl
%_bindir/logargs.sh
%_bindir/unknownuser.sh
%_bindir/eximclean

%changelog
* Thu Dec 04 2003 Victor V Ismakaev <ivv@altlinux.ru> 4.30-alt1.1
- fixes in %file and %post sections


* Thu Dec 04 2003 Victor V Ismakaev <ivv@altlinux.ru> 4.30-alt1
- rebuild with new exiscan-acl-4.30-14.patch

* Wed Dec 03 2003 Victor V Ismakaev <ivv@altlinux.ru> 4.30-alt0.1
- new version 4.30
- added whoson support
- ldap support moved from exim-base subpackage to exim-ldap subpackage
- added saslauthd auth

* Fri Sep 05 2003 Victor Forsyuk <force@altlinux.ru> 4.22-alt0.1
- New version (FAQ and config samples also updated).
- Migrate from user `exim' to `mail'.
- Change ownership of spool and log files to user 'mail' in postinstall
  script.
- Cleaned up weekly cron script.
- Optimized logrotate script.
- Fix mistake in upstream cramtest.pl fixing. :)
- Clean unneeded things from spec (defualt attrs in filelists, etc).
- Mark logrotate script as %%config file.
- Add exiqgrep to package.
- Drop dependancy on MDA (provided by procmail). Exim itself can
  deliver mail to local users.
- Fix exim-base build (it was by mistake made identical to exim-mysql).
- Add dependancy on exim-mta to main package.

* Wed Jul 30 2003 Victor V Ismakaev <ivv@altlinux.ru> 4.20-alt0.6
- applied patch exiscan-09

* Tue Jul 01 2003 Victor V Ismakaev <ivv@altlinux.ru> 4.20-alt0.5
- some fix's in exim scripts

* Mon Jun 09 2003 Victor V Ismakaev <ivv@altlinux.ru> 4.20-alt0.4
- rebuild with libdb4.1

* Thu Jun 05 2003 Victor V Ismakaev <ivv@altlinux.ru> 4.20-alt0.3
- fixing file permissions on exim's binary files

* Wed Jun 04 2003 Victor V Ismakaev <ivv@altlinux.ru> 4.20-alt0.2
- rebuild with libdb4.0
- fixing spec

* Mon Jun 02 2003 Victor V Ismakaev <ivv@altlinux.ru> 4.20-alt0.1
- first release for ALTLinux
